\documentclass[a4paper]{article}
\usepackage[ngerman]{babel}
\usepackage[utf8x]{inputenc}

\usepackage[german=guillemets]{csquotes}


%include polycode.fmt

\setlength\parindent{0pt}
\setlength{\parskip}{5pt plus 2pt minus 1pt}

\usepackage{enumitem}



\begin{document}


\author{}

\title{Übungsblatt 4 b)}

\maketitle

\section*{Aufgabe 4 b: Ein kleiner Parser für XML}
In dieser Aufgabe soll ein kleiner Parser für XML Strukturen geschrieben werden.
Dabei verwenden wir die in der Vorlesung entwickelte Parser-Kombinator Bibliothek.
Das Ergebnis soll ein XML-Dokument des in Aufgabe 4 a) Datentyps für XML sein.

> module ParseXML where
> import XML
> import OurParserLib
> import Data.Char
> import Data.List


\begin{enumerate}[label=\alph*)]

\item Implementieren Sie den Parser, der Tag- und Attributnamen parst.

Ein Name ist ein nichtleerer String, der mit einem Buchstaben (isAlpha)
oder einen der Zeichen \verb+'_'+ und \verb+':'+ begint und gefolgt wird von
einer Zeichenkette aus beliebigen Zeichen die kein Whitespace sind
und nicht eines der Zeichen \verb+'<', '/', '>', '\'', '='+ \verb+und '\"'+.

> name :: Parser Char Name

\item Implementieren Sie einen Parser, der einen schließenden XML-Tag parst.

Das Ergebnisse sei der Tagname.

Beachten Sie dass nach \verb+"</"+ kein Whitespace stehen darf, aber nach dem
Tagnamen beliebiger Whitespace stehen darf.

> closeTag :: Parser Char Name


\item Implementieren Sie einen Parser, der Attributwerte erkennt.

Ein Attributwert sei dabei eine entweder in doppelten Anführungszeichen \verb+"+ oder
in einfachen Anführungszeichen eingeschlossene Zeichenkette, in der die verwendeten
Anführungszeichen nicht verwendet werden dürfen.

Wir vernachlässigen Character-Entities. 

> value :: Parser Char Value


\item Implementieren Sie einen Parser der Attribute erkennt.

Ein Attribute hatt einen Namen gefolgt vom Gleichheitszeichen, gefolgt von einem
Attributwert. Vor und nach dem Gleichheitszeichen dürfen beliebig viele Weißzeichen
stehen.

> attribute :: Parser Char Attribute

\item Implementieren Sie einen Parser, der eine Folge von Attributen erkennt.
Vor den Attributen dürfen beliebig viele Weißzeichen stehen.

Schließen Sie Attributlisten, in denen ein Schlüssel mehrfach vor kommt, aus.

> attributes ::Parser Char [Attribute]


\item Implementieren Sie einen Parser, der ein öffnendes Element-Tag erkennt.

Ein Element-Tag beginnt mit dem Symbol \verb+<+ gefolgt von einen Namen.
Anschließend kommt eine Attributeliste. Zum Ende kommt das Symbol \verb+>+.
Vor dem letzten Symbol darf belliebig viel Weißraum stehen.

Wir vernachlässigen direkt wieder schließende Elemente der Art \verb+<tag/>+.

> openTag :: Parser Char (String, [Attribute])


\item Schreiben Sie einen Parser der beliebigen Text eines Textknotens erkennt.

Text sei eine Folge vin beliebigen Zeichen außer \verb+<+.

Wir vernachlässigen also Character-Entities, CData-Sections und vieles mehr.

> text ::Parser Char XML

\item Schreiben Sie einen Parser, der ein XML-Element erkennt.

Ein XML-Element hat ein öffnendes und ein schließendes Tag. Beide
haben denselben Tagnamen, was Sie mit der Funktion \verb+filtere+
ausdrücken können.

Zwischen öffnenden und schließenden Tag steht eine Folge von beliebigen
XMl-Knoten. Das können weitere Elemente oder Textknoten sein.

> element :: Parser Char XML

\end{enumerate}
\end{document}

